module Camila.Examples.FolderAlgOO 
(
module Camila.Examples.StackAlgOO,
module Camila.Examples.FolderAlgOO
)


where

import OOHaskell hiding (( # ), liftIO, new)
import Prelude hiding (print)
import Camila.Monad
import Pointless.Combinators

import Camila.Examples.StackAlgOO

data New deriving Typeable; new = proxy :: Proxy New
data Insert deriving Typeable; insert = proxy :: Proxy Insert
data Remove deriving Typeable; remove = proxy :: Proxy Remove
data Backward deriving Typeable; backward = proxy :: Proxy Backward
data Forward deriving Typeable; forward = proxy :: Proxy Forward


type Folder = (Stack, Stack)

folderAlg :: CamilaMonad m => f -> 
    m (Record (
        New :=: Folder
    :*: Insert :=: (Elem -> Folder -> Folder)
    :*: Remove :=: (Folder -> Folder)
    :*: Backward :=: (Folder -> Folder)
    :*: Forward :=: (Folder -> Folder)
    :*: HNil))
folderAlg self =
         do
            super <- stackAlg self
            return $
                 new .=. ((super # empty, super # empty))
             .*. insert .=. (\e -> id >< ((super # push) e))
             .*. remove .=. (id >< (super # pop))
             .*. backward .=. (backwardop super)
             .*. forward .=. (forwardop super)
             .*. emptyRecord

backwardop super f = let e = (super # top) $ fst f
                     in  ((super # pop) >< ((super # push) e)) f

forwardop super f = let e = (super # top) $ snd f
                    in  (((super # push) e) >< (super # pop)) f
        
