module Camila.Examples.FolderObjOO where

import OOHaskell hiding (( # ), liftIO, new)
import Prelude hiding (print)
import Camila.Monad
import Camila.MonadT
import Control.Monad.Trans

import Camila.Examples.FolderAlgOO

data OPNew deriving Typeable; opnew = proxy :: Proxy OPNew
data OPInsert deriving Typeable; opinsert = proxy :: Proxy OPInsert
data OPRemove deriving Typeable; opremove = proxy :: Proxy OPRemove
data OPBackward deriving Typeable; opbackward = proxy :: Proxy OPBackward
data OPForward deriving Typeable; opforward = proxy :: Proxy OPForward
data Get deriving Typeable; get = proxy :: Proxy Get


folderObj :: (CamilaMonad m, MonadRef m) => f -> 
    m (Record (
        OPNew :=: m ()
    :*: Get :=: (m Folder)
    :*: OPInsert :=: (Elem -> m ())
    :*: OPRemove :=: (m ())
    :*: OPBackward :=: (m ())
    :*: OPForward :=: (m ())  
    :*: New :=: Folder
    :*: Insert :=: (Elem -> Folder -> Folder)
    :*: Remove :=: (Folder -> Folder)
    :*: Backward :=: (Folder -> Folder)
    :*: Forward :=: (Folder -> Folder)
    :*: HNil))
folderObj self
    =
       do
        super <- folderAlg self
        f <- newRef (super # new)
        return 
              $
                 opnew .=. (modifyRef f $ const (super # new))
             .*. get .=. (readRef f)
             .*. opinsert .=. (\e -> modifyRef f $ (super # insert) e)
             .*. opremove .=. (modifyRef f (super # remove))
             .*. opbackward .=. (modifyRef f (super # backward))
             .*. opforward .=. (modifyRef f (super # forward))
             .*. super
test () = -- this argument is to force type inference (avoid monomorphism error) 
   do
    f <- mfix (folderObj)
    _ <- f # opnew
    f' <- f # get
    liftIO $ putStrLn $ show $ f'
    _ <- (f # opinsert) 1
    liftIO $ putStrLn $ show $ f'
    _ <- (f # opinsert) 2
    _ <- (f # opinsert) 3
    return f


