module Camila.Examples.StackObjOO where

import OOHaskell hiding (( # ), liftIO, new)
import Prelude hiding (print)
import Camila.Monad
import Camila.MonadT 
import Pointless.Combinators
import Camila.Examples.StackAlgOO
import Control.Monad.Trans


data OPPush deriving Typeable;  oppush     = proxy::Proxy OPPush
data OPPop  deriving Typeable;  oppop     = proxy::Proxy OPPop
data OPTop  deriving Typeable;  optop     = proxy::Proxy OPTop
data OPEmpty deriving Typeable; opempty = proxy::Proxy OPEmpty
data OPIsEmpty deriving Typeable; opisempty = proxy::Proxy OPIsEmpty
data GetStack deriving Typeable; getStack = proxy::Proxy GetStack

stackObj :: (CamilaMonad m, MonadRef m) => s ->
            m (Record (
                GetStack :=: m [Int]
            :*: OPEmpty :=: m ()
            :*: OPIsEmpty :=: m Bool
            :*: OPPush :=: (Int -> m ())
            :*: OPPop  :=: m ()
            :*: OPTop :=: m Int
            :*: Empty :=: Stack
            :*: IsEmpty :=: (Stack -> Bool)
            :*: Push :=: (Elem -> Stack -> Stack)
            :*: Pop  :=: (Stack -> Stack)
            :*: Top :=: (Stack -> Elem)
            :*: HNil))

stackObj self
    =  
       do
        super <- stackAlg self
        s <- newRef []
        return
               $ getStack .=. (readRef s)
             .*. opempty .=. (emptyop s super)
             .*. opisempty .=. (isemptyop s super)
             .*. oppush .=. (pushop super s)
             .*. oppop  .=. (popop s super) 
             .*. optop .=. (topop s super)
             .*. super


-- push operation
pushop super s i = modifyRef s ((super # push) i)

-- pop operation
popop s super = do l <- readRef s
                   pre (not $ null l)
                   modifyRef s (super # pop)

-- top operation
topop s super
        = do l <- readRef s
             pre (not $ null l)
             return ((super # top) l)

emptyop s super = modifyRef s ((!) (super # empty))

isemptyop s super = do  x <- readRef s
                        return $ (super # isempty) x

-- test pop empty stack 
testPopEmptyStack () = -- this argument is to force type inference (avoid monomorphism error) 
   do
    s <- mfix (stackObj)
    n <- s # oppop
    (s # oppush) 3
    n <- s # optop
    liftIO $ putStrLn $ show n
    return n


