-----------------------------------------------------------------------------
-- |
-- Copyright   :  (c) Joost Visser 2004
-- License     :  LGPL
-- 
-- Maintainer  :  joost.visser@di.uminho.pt
-- Stability   :  experimental
-- Portability :  portable
--
-- An implementation of relations as sets of pairs.
--
-----------------------------------------------------------------------------

module Data.Analysis.FormalConceptAnalysisQuickCheck where

import Data.Analysis.FormalConceptAnalysis
import Data.Set hiding (map)
import Data.Graph.Basics 
import Test.QuickCheck

prop_lattice cxt
  = classify (size cxt /= 0) "non-empty" $
    and (map (\c -> c `isConceptOf` cxt) (elems (ent l))) &&
    and (map (uncurry conceptGT) (elems l))
    where
      l = lattice cxt
      types = (cxt::Context Int Int)

prop_latticeInv cxt
  = classify (size cxt /= 0) "non-empty" $
    lattice cxt == dualConceptLattice (lattice (inv cxt))
    where
      types = (cxt::Context Int Int)

-----------------------------------------------------------------------------
