module Data.CamilaCollection.InfiniteSet where

import qualified Data.CamilaCollection.CamilaCollection as C
import qualified Data.CamilaSequence.CamilaSequence as S
import qualified Data.CamilaSequence.CamilaListSeq as L


-- data type definition
data InfiniteSet a = ISPred (a -> Bool)



-- functions type
moduleName :: String
empty      :: InfiniteSet a
single     :: Eq a => a -> InfiniteSet a
fromSeq    :: (S.CamilaSequence seq) => seq a -> InfiniteSet a
insert     :: a -> InfiniteSet a -> InfiniteSet a
insertSeq  :: (S.CamilaSequence seq) => seq a -> InfiniteSet a -> InfiniteSet a
union      :: InfiniteSet a -> InfiniteSet a -> InfiniteSet a
unionSeq   :: (S.CamilaSequence seq) => seq (InfiniteSet a) -> InfiniteSet a
delete     :: a -> InfiniteSet a -> InfiniteSet a
deleteAll  :: a -> InfiniteSet a -> InfiniteSet a
deleteSeq  :: (S.CamilaSequence seq) => seq a -> InfiniteSet a -> InfiniteSet a
null_       :: InfiniteSet a -> Bool
size       :: InfiniteSet a -> Int
member     :: InfiniteSet a -> a -> Bool
count      :: InfiniteSet a -> a -> Int


intersect     :: InfiniteSet a -> InfiniteSet a -> InfiniteSet a
difference    :: InfiniteSet a -> InfiniteSet a -> InfiniteSet a
subset        :: InfiniteSet a -> InfiniteSet a -> Bool
subsetEq      :: InfiniteSet a -> InfiniteSet a -> Bool



-- functions definition
empty = ISPred (const False)
single x = ISPred (== x)

fromSeq = undefined
insert = undefined
insertSeq = undefined
union (ISPred p1) (ISPred p2) = ISPred (\a -> (p1 a || p2 a))
unionSeq = undefined
delete = undefined
deleteAll= undefined
deleteSeq = undefined
null_  = undefined
size = undefined
member (ISPred p) a = p a
count = undefined
moduleName = "InfiniteSet"


intersect (ISPred p1) (ISPred p2) = ISPred (\a -> (p1 a && p2 a)) 
difference = undefined
subset = undefined
subsetEq = undefined


-- instance declarations

instance Eq a => C.CollX InfiniteSet a where
  {empty = empty; single = single; fromSeq = fromSeq; insert = insert;
   insertSeq = insertSeq; union = union; unionSeq = unionSeq;
   delete = delete; deleteAll = deleteAll; deleteSeq = deleteSeq;
   null = null_; size = size; member = member; count = count;
   instanceName c = moduleName}


instance Eq a => C.SetX InfiniteSet a where
  {intersect = intersect; difference = difference;
   subset = subset; subsetEq = subsetEq}

