-----------------------------------------------------------------------------
-- |
-- Module      :  Data.MapExtrasHUnit
-- Copyright   :  (c) Joo Ferreira, Alexandra Mendes
-- License     :  GPL
-- 
-- Maintainer  :  Joo Ferreira, Alexandra Mendes
-- Stability   :  experimental
-- Portability :  experimental
--
-- Tests for the implementation of Camila.Prelude.
--
-----------------------------------------------------------------------------

module Data.FiniteMapExtrasHUnit where

import Camila.Prelude
import Data.Set as Set
import Data.Map as Map
import HUnit

-----------------------------------------------------------------------------

main
  = runTestTT . TestList $ testList
  
labeledTest l t
  = TestLabel l (TestCase t)

testList
  = [ labeledTest "testEmpty" (
        do let fm = Map.empty :: Map Int Int 
           assertEqual "Domain should be empty" (Set.empty) (dom fm)
           assertEqual "Range should be empty" (Set.empty) (rng fm)
      ),
      labeledTest "testSingleton" (
        do let fm = Map.fromList [(1,2)] 
           assertEqual "Domain" (Set.fromList [1]) (dom fm)
           assertEqual "Range" (Set.fromList [2]) (rng fm)
      )]
-----------------------------------------------------------------------------

