{-# OPTIONS -fglasgow-exts #-}

module Data.Transform.Strafunski where

import StrategyLib

{-
import Control.Monad
-}

-- data TP' m = Monad m => MkTP' (TP m) 
-- unTP' (MkTP' s) = s

data S a where

  ID :: Monad m => S (TP m)
  SEQ :: Monad m => S (TP m) -> S (TP m) -> S (TP m)
  ALL :: Monad m => S (TP m) -> S (TP m)
  
  FAIL :: MonadPlus m => S (TP m)
  CHOICE :: MonadPlus m => S (TP m) -> S (TP m) -> S (TP m)
  ONE :: MonadPlus m => S (TP m) -> S (TP m)
  
  ADHOC :: (Monad m, Term a) => S (TP m) -> (a -> m a) -> S (TP m)

data S' m a where

  ID' :: Monad m => S' m (TP m)
  SEQ' :: Monad m => S' m (TP m) -> S' m (TP m) -> S' m (TP m)
  ALL' :: Monad m => S' m (TP m) -> S' m (TP m)
  
  FAIL' :: MonadPlus m => S' m (TP m)
  CHOICE' :: MonadPlus m => S' m (TP m) -> S' m (TP m) -> S' m (TP m)
  ONE' :: MonadPlus m => S' m (TP m) -> S' m (TP m)

eval :: S s -> s
eval ID = idTP
eval (SEQ f g) = (eval f) `seq` (eval g) 
eval (ALL f) = allTP (eval f)
eval FAIL = failTP
eval (CHOICE f g) = (eval f) `choiceTP` (eval g)
eval (ONE f) = oneTP (eval f)
eval (ADHOC f g) = adhocTP (eval f) g


eval' :: MonadPlus m => S' m s -> s
eval' ID' = idTP
eval' (SEQ' f g) = (eval' f) `seq` (eval' g) 
eval' (ALL' f) = allTP (eval' f)
eval' FAIL' = failTP
eval' (CHOICE' f g) = (eval' f) `choiceTP` (eval' g)
eval' (ONE' f) = oneTP (eval' f)

type RULE = forall a . S a -> Maybe (S a)

type RULE' m = forall a . S' m a -> Maybe (S' m a)

id_elim :: RULE
id_elim (SEQ ID g) = return g
id_elim (SEQ f ID) = return f
id_elim (ALL ID) = return ID
id_elim (CHOICE ID g) = return ID
id_elim (CHOICE f ID) = return f
id_elim (ONE ID) = return ID 
id_elim _ = mzero

fail_rule :: RULE
-- fail_rule (SEQ FAIL g) = return FAIL   --<<-- requires MonadPlus for SEQ
fail_rule (CHOICE FAIL g) = return g
fail_rule (ONE FAIL) = return FAIL
fail_rule _ = mzero

fail_rule' :: MonadPlus m => RULE' m
fail_rule' (SEQ' FAIL' g) = return FAIL' 


data Table h where
  Table :: Header h k v -> Map k v -> Table h

data Header h where
  Header :: Attributes hk k -> Attributes hv v -> Header (hk,hv)

data Attributes h v where
  NoAttrs :: Attributes () ()
  Attrs :: Attribute h v -> Attributes hs vs -> Attributes (h,hs) (v,vs)

data Attribute h v

data SQL a where
  FILTER :: (t -> Bool) -> SQL (t -> t)
  PRODUCT :: Table t -> Table
  
  SQL (t -> t')