module Language.HaLex.Mini where


import List
import Language.HaLex.Util
import Language.HaLex.Dfa
import Language.HaLex.Ndfa
import Language.HaLex.FaOperations

import Language.HaLex.Minimize
import Language.HaLex.Util


dd = Dfa ['a'] [1,2,3] 1 [3] d
  where d 1 'a' = 3
        d 2 'a' = 3
        d 3 'a' = 3


dd' = removeinaccessible dd


dd'' = ndfa2dfa . dfa2ndfa $ dd

removeinaccessible dfa@(Dfa v s i f d) = Dfa v states i (f `intersect` states) d
  where states = nub (i:(flowdown [i] (transitionTableDfa dfa)))
        flowdown zz ss = limit (\ x -> nub(x ++ nextlevel ss x)) (nextlevel ss zz)
        nextlevel ss zz = (nub . concat) [ next z ss | z <- zz ]
        next z = concat . map (\(a,_,c) -> if a == z then [c] else [])

removeinaccessible' a = ndfa2dfa . dfa2ndfa $ a

stdMinimizeDfa dfa = ttDfa2Dfa  (vs,und,bl ss ,z',list)
  where a = removeinaccessible dfa
        Dfa vs qs ss zs ds = a
        dist = distinguishable a
        und  = undistinguishable a dist
        tt = [ (q,v,z) | q <- qs , v <- vs , z <- [ds q v] ]
        list = nub [ (bl x , y , bl z ) | (x,y,z) <- tt , bl x /= [] , bl z/= [] ]
        z' = nub (filter (/=[]) (map bl zs))

        bl x = concat ([] : (filter (x `elem`) und))


undistinguishable :: Eq st => Dfa st sy -> [(st,st)] -> [[st]]
undistinguishable (Dfa _ qs _ _ _) dist = 
        eraseintersect [ i : [j | j <- qs , ne(i,j) , ne (j,i), j/= i ] | i <- qs ]
  where ne p = not (p `elem` dist)


eraseintersect :: Eq a => [[a]] -> [[a]]
eraseintersect []     = []
eraseintersect (x:xs) | (concat . map (x `intersect`)) xs == []  = x : eraseintersect xs
                      | otherwise                                = eraseintersect xs

 
distinguishable :: Eq st => Dfa st sy -> [(st,st)]
distinguishable (Dfa vs qs _ zs delta) = limit (\x -> nub (x ++ nthdist qs x)) (fstdist qs)
  where fstdist []     = []
        fstdist (x:xs) = [(x,a) | a <- xs , (x `elem` zs) /= (a `elem` zs) ] ++ fstdist xs

        nthdist []     _    = []
        nthdist (a:as) dist = [ (a,b) | b <- qs , x <- vs , move2Disting (a,b) x dist ]
                              ++ nthdist as dist

        move2Disting (a,b) x dist = (delta a x , delta b x) `elem` dist


dfa = Dfa v q s z delta
  where 
         v = "+-d"
         q = [1,2,3,4,5,6]
         s = 1
         z = [4,6]
         -- delta :: st -> sy -> st 
         delta 1 '+' = 2
         delta 1 '-' = 3
         delta 1 'd' = 4
         delta 2 '+' = 5
         delta 2 '-' = 5
         delta 2 'd' = 4
         delta 3 '+' = 5
         delta 3 '-' = 5
         delta 3 'd' = 4
         delta 4 '+' = 5
         delta 4 '-' = 5
         delta 4 'd' = 6
         delta 5 '+' = 5
         delta 5 '-' = 5
         delta 5 'd' = 5
         delta 6 '+' = 5
         delta 6 '-' = 5
         delta 6 'd' = 6
