module Language.Java.SyntaxPPInstances where
import Language.Java.Syntax
import Language.Java.SyntaxTermInstances()
import Text.PrettyPrint.HughesPJ
import GPP
import StrategyLib
 
instance PP Type where
	pp gpp (PrimitiveType _0) = fsep [gpp _0]
	pp gpp (ReferenceType _0) = fsep [gpp _0]
 
instance PP PrimitiveType where
	pp gpp (NumericType _0) = fsep [gpp _0]
	pp gpp (Boolean) = fsep [gpp "boolean"]
 
instance PP NumericType where
	pp gpp (IntegralType _0) = fsep [gpp _0]
	pp gpp (FloatingPointType _0) = fsep [gpp _0]
 
instance PP IntegralType where
	pp gpp (Byte) = fsep [gpp "byte"]
	pp gpp (Short) = fsep [gpp "short"]
	pp gpp (Int) = fsep [gpp "int"]
	pp gpp (Long) = fsep [gpp "long"]
	pp gpp (Char) = fsep [gpp "char"]
 
instance PP FloatingPointType where
	pp gpp (Float) = fsep [gpp "float"]
	pp gpp (Double) = fsep [gpp "double"]
 
instance PP ReferenceType where
	pp gpp (ClassOrInterfaceType _0) = fsep [gpp _0]
	pp gpp (ArrayType _0) = fsep [gpp _0]
 
instance PP ClassOrInterfaceType where
	pp gpp (Name _0) = fsep [gpp _0]
 
instance PP ClassType where
	pp gpp (ClassOrInterfaceType1 _0) = fsep [gpp _0]
 
instance PP InterfaceType where
	pp gpp (ClassOrInterfaceType2 _0) = fsep [gpp _0]
 
instance PP ArrayType where
	pp gpp (PrimitiveType1 _0) = fsep [gpp _0, gpp "[", gpp "]"]
	pp gpp (ArrayType0 _0) = fsep [gpp _0, gpp "[", gpp "]"]
	pp gpp (ArrayType1 _0) = fsep [gpp _0, gpp "[", gpp "]"]
 
instance PP Block where
	pp gpp (BlockStatement_s _1)
	  = fsep [gpp "{", gppList gpp _1, gpp "}"]
 
instance PP BlockStatement where
	pp gpp (LocalVariableDeclarationStatement _0) = fsep [gpp _0]
	pp gpp (Statement _0) = fsep [gpp _0]
 
instance PP LocalVariableDeclarationStatement where
	pp gpp (Semicolon _0) = fsep [gpp _0, gpp ";"]
 
instance PP LocalVariableDeclaration where
	pp gpp (Comma _0 _1) = fsep [gpp _0, gppListSep gpp "," _1]
 
instance PP Statement where
	pp gpp (StatementWithoutTrailingSubstatement _0) = fsep [gpp _0]
	pp gpp (LabeledStatement _0) = fsep [gpp _0]
	pp gpp (IfThenStatement _0) = fsep [gpp _0]
	pp gpp (IfThenElseStatement _0) = fsep [gpp _0]
	pp gpp (WhileStatement _0) = fsep [gpp _0]
	pp gpp (ForStatement _0) = fsep [gpp _0]
	pp gpp (ClassDeclaration _0) = fsep [gpp _0]
 
instance PP StatementNoShortIf where
	pp gpp (StatementWithoutTrailingSubstatement1 _0) = fsep [gpp _0]
	pp gpp (LabeledStatementNoShortIf _0) = fsep [gpp _0]
	pp gpp (IfThenElseStatementNoShortIf _0) = fsep [gpp _0]
	pp gpp (WhileStatementNoShortIf _0) = fsep [gpp _0]
	pp gpp (ForStatementNoShortIf _0) = fsep [gpp _0]
 
instance PP StatementWithoutTrailingSubstatement where
	pp gpp (Block _0) = fsep [gpp _0]
	pp gpp (EmptyStatement _0) = fsep [gpp _0]
	pp gpp (ExpressionStatement _0) = fsep [gpp _0]
	pp gpp (SwitchStatement _0) = fsep [gpp _0]
	pp gpp (DoStatement _0) = fsep [gpp _0]
	pp gpp (BreakStatement _0) = fsep [gpp _0]
	pp gpp (ContinueStatement _0) = fsep [gpp _0]
	pp gpp (ReturnStatement _0) = fsep [gpp _0]
	pp gpp (SynchronizedStatement _0) = fsep [gpp _0]
	pp gpp (ThrowStatement _0) = fsep [gpp _0]
	pp gpp (TryStatement _0) = fsep [gpp _0]
 
instance PP EmptyStatement where
	pp gpp (Semicolon1) = fsep [gpp ";"]
 
instance PP LabeledStatement where
	pp gpp (Colon _0 _2) = fsep [gpp _0, gpp ":", gpp _2]
 
instance PP LabeledStatementNoShortIf where
	pp gpp (Colon1 _0 _2) = fsep [gpp _0, gpp ":", gpp _2]
 
instance PP ExpressionStatement where
	pp gpp (Semicolon2 _0) = fsep [gpp _0, gpp ";"]
 
instance PP StatementExpression where
	pp gpp (MethodInvocation _0) = fsep [gpp _0]
	pp gpp (ClassInstanceCreationExpression _0) = fsep [gpp _0]
	pp gpp (Incr2 _0) = fsep [gpp _0, gpp "++"]
	pp gpp (Decr2 _0) = fsep [gpp _0, gpp "__"]
	pp gpp (Incr3 _1) = fsep [gpp "++", gpp _1]
	pp gpp (Decr3 _1) = fsep [gpp "__", gpp _1]
	pp gpp (Assignment _0) = fsep [gpp _0]
 
instance PP IfThenStatement where
	pp gpp (If _2 _4)
	  = fsep [gpp "if", gpp "(", gpp _2, gpp ")", gpp _4]
 
instance PP IfThenElseStatement where
	pp gpp (If_else _2 _4 _6)
	  = fsep
	      [gpp "if", gpp "(", gpp _2, gpp ")", gpp _4, gpp "else", gpp _6]
 
instance PP IfThenElseStatementNoShortIf where
	pp gpp (If_else1 _2 _4 _6)
	  = fsep
	      [gpp "if", gpp "(", gpp _2, gpp ")", gpp _4, gpp "else", gpp _6]
 
instance PP SwitchStatement where
	pp gpp (Switch _2 _4)
	  = fsep [gpp "switch", gpp "(", gpp _2, gpp ")", gpp _4]
 
instance PP SwitchBlock where
	pp gpp (SwitchBlockStatementGroup_s_SwitchLabel_s _1 _2)
	  = fsep [gpp "{", gppList gpp _1, gppList gpp _2, gpp "}"]
 
instance PP SwitchBlockStatementGroup where
	pp gpp (SwitchLabel_p_BlockStatement_p _0 _1)
	  = fsep [gppList gpp _0, gppList gpp _1]
 
instance PP SwitchLabel where
	pp gpp (Case_colon _1) = fsep [gpp "case", gpp _1, gpp ":"]
	pp gpp (Default_colon) = fsep [gpp "default", gpp ":"]
 
instance PP WhileStatement where
	pp gpp (While _2 _4)
	  = fsep [gpp "while", gpp "(", gpp _2, gpp ")", gpp _4]
 
instance PP WhileStatementNoShortIf where
	pp gpp (While1 _2 _4)
	  = fsep [gpp "while", gpp "(", gpp _2, gpp ")", gpp _4]
 
instance PP DoStatement where
	pp gpp (Do_while_semicolon _1 _4)
	  = fsep
	      [gpp "do", gpp _1, gpp "while", gpp "(", gpp _4, gpp ")", gpp ";"]
 
instance PP ForStatement where
	pp gpp (For_semicolon_semicolon _2 _4 _6 _8)
	  = fsep
	      [gpp "for", gpp "(", gppMaybe gpp _2, gpp ";", gppMaybe gpp _4,
	       gpp ";", gppMaybe gpp _6, gpp ")", gpp _8]
 
instance PP ForStatementNoShortIf where
	pp gpp (For_semicolon_semicolon1 _2 _4 _6 _8)
	  = fsep
	      [gpp "for", gpp "(", gppMaybe gpp _2, gpp ";", gppMaybe gpp _4,
	       gpp ";", gppMaybe gpp _6, gpp ")", gpp _8]
 
instance PP ForInit where
	pp gpp (StatementExpressionListForInit _0) = fsep [gpp _0]
	pp gpp (LocalVariableDeclaration _0) = fsep [gpp _0]
 
instance PP ForUpdate where
	pp gpp (StatementExpressionList1 _0) = fsep [gpp _0]
 
instance PP StatementExpressionList where
	pp gpp (StatementExpressionList _0) = fsep [gppListSep gpp "," _0]
 
instance PP BreakStatement where
	pp gpp (Break_semicolon _1)
	  = fsep [gpp "break", gppMaybe gpp _1, gpp ";"]
 
instance PP ContinueStatement where
	pp gpp (Continue_semicolon _1)
	  = fsep [gpp "continue", gppMaybe gpp _1, gpp ";"]
 
instance PP ReturnStatement where
	pp gpp (Return_semicolon _1)
	  = fsep [gpp "return", gppMaybe gpp _1, gpp ";"]
 
instance PP ThrowStatement where
	pp gpp (Throw_semicolon _1) = fsep [gpp "throw", gpp _1, gpp ";"]
 
instance PP SynchronizedStatement where
	pp gpp (Synchronized _2 _4)
	  = fsep [gpp "synchronized", gpp "(", gpp _2, gpp ")", gpp _4]
 
instance PP TryStatement where
	pp gpp (Try _1 _2) = fsep [gpp "try", gpp _1, gppList gpp _2]
	pp gpp (Try1 _1 _2 _3)
	  = fsep [gpp "try", gpp _1, gppList gpp _2, gpp _3]
 
instance PP CatchClause where
	pp gpp (Catch _2 _4)
	  = fsep [gpp "catch", gpp "(", gpp _2, gpp ")", gpp _4]
 
instance PP Finally where
	pp gpp (Finally _1) = fsep [gpp "finally", gpp _1]
 
instance PP Name where
	pp gpp (Identifier_p _0) = fsep [gppListSep gpp "." _0]
	pp gpp (Class _0)
	  = fsep [gppListSep gpp "." _0, gpp ".", gpp "class"]
 
instance PP SimpleName where
	pp gpp (Identifier _0) = fsep [gpp _0]
 
instance PP Modifier where
	pp gpp (Public) = fsep [gpp "public"]
	pp gpp (Protected) = fsep [gpp "protected"]
	pp gpp (Private) = fsep [gpp "private"]
	pp gpp (Static) = fsep [gpp "static"]
	pp gpp (Abstract) = fsep [gpp "abstract"]
	pp gpp (Final) = fsep [gpp "final"]
	pp gpp (Native) = fsep [gpp "native"]
	pp gpp (Synchronized1) = fsep [gpp "synchronized"]
	pp gpp (Transient) = fsep [gpp "transient"]
	pp gpp (Volatile) = fsep [gpp "volatile"]
 
instance PP MethodDeclaration where
	pp gpp (MethodHeader_MethodBody _0 _1) = fsep [gpp _0, gpp _1]
 
instance PP MethodHeader where
	pp gpp (Modifier_s_Type_MethodDeclarator_Throws_opt _0 _1 _2 _3)
	  = fsep [gppList gpp _0, gpp _1, gpp _2, gppMaybe gpp _3]
	pp gpp (Void _0 _2 _3)
	  = fsep [gppList gpp _0, gpp "void", gpp _2, gppMaybe gpp _3]
 
instance PP MethodDeclarator where
	pp gpp (Comma2 _0 _2)
	  = fsep [gpp _0, gpp "(", gppListSep gpp "," _2, gpp ")"]
	pp gpp (MethodDeclarator _0) = fsep [gpp _0, gpp "[", gpp "]"]
 
instance PP FormalParameter where
	pp gpp (Type_VariableDeclaratorId _0 _1) = fsep [gpp _0, gpp _1]
 
instance PP Throws where
	pp gpp (Throws_comma _1)
	  = fsep [gpp "throws", gppListSep gpp "," _1]
 
instance PP MethodBody where
	pp gpp (Block1 _0) = fsep [gpp _0]
	pp gpp (Semicolon3) = fsep [gpp ";"]
 
instance PP IntegerLiteral where
	pp gpp (DecimalIntegerLiteral _0) = fsep [gpp _0]
	pp gpp (HexIntegerLiteral _0) = fsep [gpp _0]
	pp gpp (OctalIntegerLiteral _0) = fsep [gpp _0]
 
instance PP Literal where
	pp gpp (IntegerLiteral _0) = fsep [gpp _0]
	pp gpp (FloatingPointLiteral _0) = fsep [gpp _0]
	pp gpp (BooleanLiteral _0) = fsep [gpp _0]
	pp gpp (CharacterLiteral _0) = fsep [gpp _0]
	pp gpp (StringLiteral _0) = fsep [gpp _0]
	pp gpp (NullLiteral _0) = fsep [gpp _0]
 
instance PP InterfaceDeclaration where
	pp gpp (Interface _0 _2 _3 _4)
	  = fsep
	      [gppList gpp _0, gpp "interface", gpp _2, gppMaybe gpp _3, gpp _4]
 
instance PP ExtendsInterfaces where
	pp gpp (Extends_comma _1)
	  = fsep [gpp "extends", gppListSep gpp "," _1]
 
instance PP InterfaceBody where
	pp gpp (InterfaceMemberDeclaration_s _1)
	  = fsep [gpp "{", gppList gpp _1, gpp "}"]
 
instance PP InterfaceMemberDeclaration where
	pp gpp (ConstantDeclaration _0) = fsep [gpp _0]
	pp gpp (AbstractMethodDeclaration _0) = fsep [gpp _0]
 
instance PP ConstantDeclaration where
	pp gpp (FieldDeclaration _0) = fsep [gpp _0]
 
instance PP AbstractMethodDeclaration where
	pp gpp (Semicolon4 _0) = fsep [gpp _0, gpp ";"]
 
instance PP FieldDeclaration where
	pp gpp (Comma_semicolon _0 _1 _2)
	  = fsep [gppList gpp _0, gpp _1, gppListSep gpp "," _2, gpp ";"]
 
instance PP VariableDeclarator where
	pp gpp (VariableDeclaratorId _0) = fsep [gpp _0]
	pp gpp (Equal _0 _2) = fsep [gpp _0, gpp "=", gpp _2]
 
instance PP VariableDeclaratorId where
	pp gpp (Identifier1 _0) = fsep [gpp _0]
	pp gpp (VariableDeclaratorId1 _0) = fsep [gpp _0, gpp "[", gpp "]"]
 
instance PP VariableInitializer where
	pp gpp (Expression _0) = fsep [gpp _0]
	pp gpp (ArrayInitializer _0) = fsep [gpp _0]
 
instance PP ArrayInitializer where
	pp gpp (Comma_comma _1 _2)
	  = fsep [gpp "{", gppListSep gpp "," _1, gppMaybe gpp _2, gpp "}"]
 
instance PP Primary where
	pp gpp (PrimaryNoNewArray _0) = fsep [gpp _0]
	pp gpp (ArrayCreationExpression _0) = fsep [gpp _0]
 
instance PP PrimaryNoNewArray where
	pp gpp (Literal _0) = fsep [gpp _0]
	pp gpp (This0) = fsep [gpp "this"]
	pp gpp (This1 _0) = fsep [gpp _0, gpp ".", gpp "this"]
	pp gpp (Expression1 _1) = fsep [gpp "(", gpp _1, gpp ")"]
	pp gpp (ClassInstanceCreationExpression1 _0) = fsep [gpp _0]
	pp gpp (FieldAccess _0) = fsep [gpp _0]
	pp gpp (MethodInvocation1 _0) = fsep [gpp _0]
	pp gpp (ArrayAccess _0) = fsep [gpp _0]
 
instance PP ClassInstanceCreationExpression where
	pp gpp (New_comma _1 _3)
	  = fsep [gpp "new", gpp _1, gpp "(", gppListSep gpp "," _3, gpp ")"]
	pp gpp (New_comma1 _1 _3 _5)
	  = fsep
	      [gpp "new", gpp _1, gpp "(", gppListSep gpp "," _3, gpp ")",
	       gpp _5]
 
instance PP ArrayCreationExpression where
	pp gpp (New _1 _2 _3)
	  = fsep [gpp "new", gpp _1, gppList gpp _2, gppList gpp _3]
	pp gpp (New1 _1 _2 _3)
	  = fsep [gpp "new", gpp _1, gppList gpp _2, gppList gpp _3]
	pp gpp (New2 _1 _2 _3)
	  = fsep [gpp "new", gpp _1, gppList gpp _2, gpp _3]
 
instance PP DimExprInitialized where
	pp gpp (Expression_opt _1)
	  = fsep [gpp "[", gppMaybe gpp _1, gpp "]"]
 
instance PP DimExpr where
	pp gpp (Expression2 _1) = fsep [gpp "[", gpp _1, gpp "]"]
 
instance PP Dim where
	pp gpp (Dim_dunno_a_0) = fsep [gpp "[", gpp "]"]
 
instance PP FieldAccess where
	pp gpp (Name1 _0) = fsep [gpp _0]
	pp gpp (Primary_Identifier _0 _2) = fsep [gpp _0, gpp ".", gpp _2]
	pp gpp (Super _2) = fsep [gpp "super", gpp ".", gpp _2]
 
instance PP MethodInvocation where
	pp gpp (NameMethodInvocation _0 _2)
	  = fsep [gpp _0, gpp "(", gppListSep gpp "," _2, gpp ")"]
	pp gpp (PrimaryMethodInvocation _0 _2 _4)
	  = fsep
	      [gpp _0, gpp ".", gpp _2, gpp "(", gppListSep gpp "," _4, gpp ")"]
	pp gpp (SuperMethodInvocation _2 _4)
	  = fsep
	      [gpp "super", gpp ".", gpp _2, gpp "(", gppListSep gpp "," _4,
	       gpp ")"]
 
instance PP ArrayAccess where
	pp gpp (Name_Expression _0 _2)
	  = fsep [gpp _0, gpp "[", gpp _2, gpp "]"]
	pp gpp (PrimaryNoNewArray_Expression _0 _2)
	  = fsep [gpp _0, gpp "[", gpp _2, gpp "]"]
 
instance PP Expression where
	pp gpp (Primary _0) = fsep [gpp _0]
	pp gpp (Plus _1) = fsep [gpp "+", gpp _1]
	pp gpp (Minus _1) = fsep [gpp "_", gpp _1]
	pp gpp (Tilde _1) = fsep [gpp "~", gpp _1]
	pp gpp (Not _1) = fsep [gpp "!", gpp _1]
	pp gpp (PrimitiveType_Dim_s_Expression _1 _2 _4)
	  = fsep [gpp "(", gpp _1, gppList gpp _2, gpp ")", gpp _4]
	pp gpp (Expression_Expression2 _1 _3)
	  = fsep [gpp "(", gpp _1, gpp ")", gpp _3]
	pp gpp (Name_Dim_p_Expression _1 _2 _4)
	  = fsep [gpp "(", gpp _1, gppList gpp _2, gpp ")", gpp _4]
	pp gpp (Expression_times_or_div_or_mod_Expression1 _0 _1 _2)
	  = fsep [gpp _0, gpp _1, gpp _2]
	pp gpp (Expression_plus_or_minus_Expression1 _0 _1 _2)
	  = fsep [gpp _0, gpp _1, gpp _2]
	pp gpp
	  (Expression_shift_left_or_shift_right_or_Expression1 _0 _1 _2)
	  = fsep [gpp _0, gpp _1, gpp _2]
	pp gpp (Expression_lt_or_gt_or_le_or_ge_Expression1 _0 _1 _2)
	  = fsep [gpp _0, gpp _1, gpp _2]
	pp gpp (Instanceof _0 _2) = fsep [gpp _0, gpp "instanceof", gpp _2]
	pp gpp (Expression_equal_or_not_equal_Expression1 _0 _1 _2)
	  = fsep [gpp _0, gpp _1, gpp _2]
	pp gpp (Address1 _0 _2) = fsep [gpp _0, gpp "&", gpp _2]
	pp gpp (Expression_Expression3 _0 _2)
	  = fsep [gpp _0, gpp "^", gpp _2]
	pp gpp (Bar1 _0 _2) = fsep [gpp _0, gpp "|", gpp _2]
	pp gpp (And1 _0 _2) = fsep [gpp _0, gpp "&&", gpp _2]
	pp gpp (Or1 _0 _2) = fsep [gpp _0, gpp "||", gpp _2]
	pp gpp (Colon2 _0 _2 _4)
	  = fsep [gpp _0, gpp "?", gpp _2, gpp ":", gpp _4]
	pp gpp (StatementExpression _0) = fsep [gpp _0]
	pp gpp (Assignment1 _0) = fsep [gpp _0]
 
instance PP TempHuub1 where
	pp gpp (Temphuub1_1) = fsep [gpp "*"]
	pp gpp (Temphuub1_2) = fsep [gpp "/"]
	pp gpp (Temphuub1_3) = fsep [gpp "%"]
 
instance PP TempHuub2 where
	pp gpp (Temphuub2_1) = fsep [gpp "+"]
	pp gpp (Temphuub2_2) = fsep [gpp "_"]
 
instance PP TempHuub3 where
	pp gpp (Temphuub3_1) = fsep [gpp "<<"]
	pp gpp (Temphuub3_2) = fsep [gpp ">>"]
	pp gpp (Temphuub3_3) = fsep [gpp ">>>"]
 
instance PP TempHuub4 where
	pp gpp (Temphuub4_1) = fsep [gpp "<"]
	pp gpp (Temphuub4_2) = fsep [gpp ">"]
	pp gpp (Temphuub4_3) = fsep [gpp "<="]
	pp gpp (Temphuub4_4) = fsep [gpp ">="]
 
instance PP TempHuub5 where
	pp gpp (Temphuub5_1) = fsep [gpp "=="]
	pp gpp (Temphuub5_2) = fsep [gpp "!="]
 
instance PP Assignment where
	pp gpp (LeftHandSide_AssignmentOperator_Expression _0 _1 _2)
	  = fsep [gpp _0, gpp _1, gpp _2]
 
instance PP LeftHandSide where
	pp gpp (Name2 _0) = fsep [gpp _0]
	pp gpp (FieldAccess1 _0) = fsep [gpp _0]
	pp gpp (ArrayAccess1 _0) = fsep [gpp _0]
 
instance PP AssignmentOperator where
	pp gpp (Equal1) = fsep [gpp "="]
	pp gpp (AssignMul) = fsep [gpp "*="]
	pp gpp (AssignDiv) = fsep [gpp "/="]
	pp gpp (AssignMod) = fsep [gpp "%="]
	pp gpp (AssignPlus) = fsep [gpp "+="]
	pp gpp (AssignMin) = fsep [gpp "_="]
	pp gpp (AssignSL) = fsep [gpp "<<="]
	pp gpp (AssignSR) = fsep [gpp ">>="]
	pp gpp (AssignmentOperator_dunno_b_0) = fsep [gpp ">>>="]
	pp gpp (AssignAnd) = fsep [gpp "&="]
	pp gpp (AssignExp) = fsep [gpp "^="]
	pp gpp (AssignOr) = fsep [gpp "|="]
 
instance PP ConstructorDeclaration where
	pp gpp
	  (Modifier_s_ConstructorDeclarator_Throws_opt_ConstructorBody _0 _1
	     _2 _3)
	  = fsep [gppList gpp _0, gpp _1, gppMaybe gpp _2, gpp _3]
 
instance PP ConstructorDeclarator where
	pp gpp (Comma5 _0 _2)
	  = fsep [gpp _0, gpp "(", gppListSep gpp "," _2, gpp ")"]
 
instance PP ConstructorBody where
	pp gpp (ExplicitConstructorInvocation_opt_BlockStatement_s _1 _2)
	  = fsep [gpp "{", gppMaybe gpp _1, gppList gpp _2, gpp "}"]
 
instance PP ExplicitConstructorInvocation where
	pp gpp (This_comma_semicolon _2)
	  = fsep
	      [gpp "this", gpp "(", gppListSep gpp "," _2, gpp ")", gpp ";"]
	pp gpp (Super_comma_semicolon _2)
	  = fsep
	      [gpp "super", gpp "(", gppListSep gpp "," _2, gpp ")", gpp ";"]
 
instance PP ClassDeclaration where
	pp gpp (Class1 _0 _2 _3 _4 _5)
	  = fsep
	      [gppList gpp _0, gpp "class", gpp _2, gppMaybe gpp _3,
	       gppMaybe gpp _4, gpp _5]
 
instance PP Super where
	pp gpp (Extends _1) = fsep [gpp "extends", gpp _1]
 
instance PP Interfaces where
	pp gpp (Implements_comma _1)
	  = fsep [gpp "implements", gppListSep gpp "," _1]
 
instance PP ClassBody where
	pp gpp (ClassBodyDeclaration_s _1)
	  = fsep [gpp "{", gppList gpp _1, gpp "}"]
 
instance PP ClassBodyDeclaration where
	pp gpp (ClassMemberDeclaration _0) = fsep [gpp _0]
	pp gpp (StaticInitializer _0) = fsep [gpp _0]
	pp gpp (ConstructorDeclaration _0) = fsep [gpp _0]
	pp gpp (EmptyClassBodyDeclaration) = fsep [gpp ";"]
	pp gpp (ClassDeclaration1 _0) = fsep [gpp _0]
	pp gpp (ClassDeclaration2 _0) = fsep [gpp _0]
 
instance PP ClassMemberDeclaration where
	pp gpp (FieldDeclaration1 _0) = fsep [gpp _0]
	pp gpp (MethodDeclaration _0) = fsep [gpp _0]
 
instance PP StaticInitializer where
	pp gpp (Static1 _1) = fsep [gpp "static", gpp _1]
 
instance PP File where
	pp gpp (File_with_header _0 _1) = fsep [gpp _0, gpp _1]
 
instance PP CompilationUnit where
	pp gpp (CU _0 _1 _2)
	  = fsep [gppMaybe gpp _0, gppList gpp _1, gppList gpp _2]
 
instance PP PackageDeclaration where
	pp gpp (Package_semicolon _1)
	  = fsep [gpp "package", gpp _1, gpp ";"]
 
instance PP ImportDeclaration where
	pp gpp (SingleTypeImportDeclaration _0) = fsep [gpp _0]
	pp gpp (TypeImportOnDemandDeclaration _0) = fsep [gpp _0]
 
instance PP SingleTypeImportDeclaration where
	pp gpp (Import_semicolon _1) = fsep [gpp "import", gpp _1, gpp ";"]
 
instance PP TypeImportOnDemandDeclaration where
	pp gpp (Import_times_semicolon _1)
	  = fsep [gpp "import", gpp _1, gpp ".", gpp "*", gpp ";"]
 
instance PP TypeDeclaration where
	pp gpp (ClassTypeDeclaration _0) = fsep [gpp _0]
	pp gpp (InterfaceDeclaration _0) = fsep [gpp _0]
	pp gpp (Semicolon5) = fsep [gpp ";"]
 
instance PP CompilationUnits where
	pp gpp (CompilationUnits _0) = fsep [gppList gpp _0]
 
uppJava :: UPP
uppJava gpp
  = (constTU empty) `adhocQ` (pp gpp :: MonoPP String) `adhocQ`
      (pp gpp :: MonoPP Type)
      `adhocQ` (pp gpp :: MonoPP PrimitiveType)
      `adhocQ` (pp gpp :: MonoPP NumericType)
      `adhocQ` (pp gpp :: MonoPP IntegralType)
      `adhocQ` (pp gpp :: MonoPP FloatingPointType)
      `adhocQ` (pp gpp :: MonoPP ReferenceType)
      `adhocQ` (pp gpp :: MonoPP ClassOrInterfaceType)
      `adhocQ` (pp gpp :: MonoPP ClassType)
      `adhocQ` (pp gpp :: MonoPP InterfaceType)
      `adhocQ` (pp gpp :: MonoPP ArrayType)
      `adhocQ` (pp gpp :: MonoPP Block)
      `adhocQ` (pp gpp :: MonoPP BlockStatement)
      `adhocQ` (pp gpp :: MonoPP LocalVariableDeclarationStatement)
      `adhocQ` (pp gpp :: MonoPP LocalVariableDeclaration)
      `adhocQ` (pp gpp :: MonoPP Statement)
      `adhocQ` (pp gpp :: MonoPP StatementNoShortIf)
      `adhocQ` (pp gpp :: MonoPP StatementWithoutTrailingSubstatement)
      `adhocQ` (pp gpp :: MonoPP EmptyStatement)
      `adhocQ` (pp gpp :: MonoPP LabeledStatement)
      `adhocQ` (pp gpp :: MonoPP LabeledStatementNoShortIf)
      `adhocQ` (pp gpp :: MonoPP ExpressionStatement)
      `adhocQ` (pp gpp :: MonoPP StatementExpression)
      `adhocQ` (pp gpp :: MonoPP IfThenStatement)
      `adhocQ` (pp gpp :: MonoPP IfThenElseStatement)
      `adhocQ` (pp gpp :: MonoPP IfThenElseStatementNoShortIf)
      `adhocQ` (pp gpp :: MonoPP SwitchStatement)
      `adhocQ` (pp gpp :: MonoPP SwitchBlock)
      `adhocQ` (pp gpp :: MonoPP SwitchBlockStatementGroup)
      `adhocQ` (pp gpp :: MonoPP SwitchLabel)
      `adhocQ` (pp gpp :: MonoPP WhileStatement)
      `adhocQ` (pp gpp :: MonoPP WhileStatementNoShortIf)
      `adhocQ` (pp gpp :: MonoPP DoStatement)
      `adhocQ` (pp gpp :: MonoPP ForStatement)
      `adhocQ` (pp gpp :: MonoPP ForStatementNoShortIf)
      `adhocQ` (pp gpp :: MonoPP ForInit)
      `adhocQ` (pp gpp :: MonoPP ForUpdate)
      `adhocQ` (pp gpp :: MonoPP StatementExpressionList)
      `adhocQ` (pp gpp :: MonoPP BreakStatement)
      `adhocQ` (pp gpp :: MonoPP ContinueStatement)
      `adhocQ` (pp gpp :: MonoPP ReturnStatement)
      `adhocQ` (pp gpp :: MonoPP ThrowStatement)
      `adhocQ` (pp gpp :: MonoPP SynchronizedStatement)
      `adhocQ` (pp gpp :: MonoPP TryStatement)
      `adhocQ` (pp gpp :: MonoPP CatchClause)
      `adhocQ` (pp gpp :: MonoPP Finally)
      `adhocQ` (pp gpp :: MonoPP Name)
      `adhocQ` (pp gpp :: MonoPP SimpleName)
      `adhocQ` (pp gpp :: MonoPP Modifier)
      `adhocQ` (pp gpp :: MonoPP MethodDeclaration)
      `adhocQ` (pp gpp :: MonoPP MethodHeader)
      `adhocQ` (pp gpp :: MonoPP MethodDeclarator)
      `adhocQ` (pp gpp :: MonoPP FormalParameter)
      `adhocQ` (pp gpp :: MonoPP Throws)
      `adhocQ` (pp gpp :: MonoPP MethodBody)
      `adhocQ` (pp gpp :: MonoPP IntegerLiteral)
      `adhocQ` (pp gpp :: MonoPP Literal)
      `adhocQ` (pp gpp :: MonoPP InterfaceDeclaration)
      `adhocQ` (pp gpp :: MonoPP ExtendsInterfaces)
      `adhocQ` (pp gpp :: MonoPP InterfaceBody)
      `adhocQ` (pp gpp :: MonoPP InterfaceMemberDeclaration)
      `adhocQ` (pp gpp :: MonoPP ConstantDeclaration)
      `adhocQ` (pp gpp :: MonoPP AbstractMethodDeclaration)
      `adhocQ` (pp gpp :: MonoPP FieldDeclaration)
      `adhocQ` (pp gpp :: MonoPP VariableDeclarator)
      `adhocQ` (pp gpp :: MonoPP VariableDeclaratorId)
      `adhocQ` (pp gpp :: MonoPP VariableInitializer)
      `adhocQ` (pp gpp :: MonoPP ArrayInitializer)
      `adhocQ` (pp gpp :: MonoPP Primary)
      `adhocQ` (pp gpp :: MonoPP PrimaryNoNewArray)
      `adhocQ` (pp gpp :: MonoPP ClassInstanceCreationExpression)
      `adhocQ` (pp gpp :: MonoPP ArrayCreationExpression)
      `adhocQ` (pp gpp :: MonoPP DimExprInitialized)
      `adhocQ` (pp gpp :: MonoPP DimExpr)
      `adhocQ` (pp gpp :: MonoPP Dim)
      `adhocQ` (pp gpp :: MonoPP FieldAccess)
      `adhocQ` (pp gpp :: MonoPP MethodInvocation)
      `adhocQ` (pp gpp :: MonoPP ArrayAccess)
      `adhocQ` (pp gpp :: MonoPP Expression)
      `adhocQ` (pp gpp :: MonoPP TempHuub1)
      `adhocQ` (pp gpp :: MonoPP TempHuub2)
      `adhocQ` (pp gpp :: MonoPP TempHuub3)
      `adhocQ` (pp gpp :: MonoPP TempHuub4)
      `adhocQ` (pp gpp :: MonoPP TempHuub5)
      `adhocQ` (pp gpp :: MonoPP Assignment)
      `adhocQ` (pp gpp :: MonoPP LeftHandSide)
      `adhocQ` (pp gpp :: MonoPP AssignmentOperator)
      `adhocQ` (pp gpp :: MonoPP ConstructorDeclaration)
      `adhocQ` (pp gpp :: MonoPP ConstructorDeclarator)
      `adhocQ` (pp gpp :: MonoPP ConstructorBody)
      `adhocQ` (pp gpp :: MonoPP ExplicitConstructorInvocation)
      `adhocQ` (pp gpp :: MonoPP ClassDeclaration)
      `adhocQ` (pp gpp :: MonoPP Super)
      `adhocQ` (pp gpp :: MonoPP Interfaces)
      `adhocQ` (pp gpp :: MonoPP ClassBody)
      `adhocQ` (pp gpp :: MonoPP ClassBodyDeclaration)
      `adhocQ` (pp gpp :: MonoPP ClassMemberDeclaration)
      `adhocQ` (pp gpp :: MonoPP StaticInitializer)
      `adhocQ` (pp gpp :: MonoPP File)
      `adhocQ` (pp gpp :: MonoPP CompilationUnit)
      `adhocQ` (pp gpp :: MonoPP PackageDeclaration)
      `adhocQ` (pp gpp :: MonoPP ImportDeclaration)
      `adhocQ` (pp gpp :: MonoPP SingleTypeImportDeclaration)
      `adhocQ` (pp gpp :: MonoPP TypeImportOnDemandDeclaration)
      `adhocQ` (pp gpp :: MonoPP TypeDeclaration)
      `adhocQ` (pp gpp :: MonoPP CompilationUnits)
