-----------------------------------------------------------------------------
-- |
-- Maintainer  :  Patrick Machado
-- Stability   :  experimental
-- Portability :  portable
--
-- Unit tests for Language.Java.CallGraphInference
--
-----------------------------------------------------------------------------

module Language.Java.TypeInferenceHUnit where

import HUnit
import Debug.HUnitExtras

import Language.Java.Syntax
import Language.Java.TypeInference
import Language.Java.Declarations

-----------------------------------------------------------------------------

main :: IO Counts
main = runTestsTT [
  labeledTest "Literals"  $ do
    let l1 = "1"
    let l2 = "1.0"
    let l3 = "true"
    let l4 = "false"
    let l5 = "'a'"

    (lit1::Literal) <- parseString l1 "Literal" javaTable
    (lit2::Literal) <- parseString l2 "Literal" javaTable
    (lit3::Literal) <- parseString l3 "Literal" javaTable
    (lit4::Literal) <- parseString l4 "Literal" javaTable
    (lit5::Literal) <- parseString l5 "Literal" javaTable

    let r1 = findTypeOf emptyDec "X" lit1
    let r2 = findTypeOf emptyDec "X" lit2
    let r3 = findTypeOf emptyDec "X" lit3
    let r4 = findTypeOf emptyDec "X" lit4
    let r5 = findTypeOf emptyDec "X" lit5

    let t1 = Just "int"
    let t2 = Just "float"
    let t3 = Just "boolean"
    let t4 = Just "boolean"
    let t5 = Just "char"

    assertEqual "should be integer" t1 r1
    assertEqual "should be float" t2 r2
    assertEqual "should be boolean" t3 r3
    assertEqual "should be boolean" t4 r4
    assertEqual "should be char" t5 r5
 ]

javaTable :: String
javaTable = "Language/Java/Java.tbl"

 
-----------------------------------------------------------------------------
