-------------------------------------------------------------------------------
--
-- | 
-- Module      :  Language.PLSql.Pretty
-- Copyright   :  (c) Tiago Alves, Paulo Silva, 2005
-- License     :  LGPL
-- 
-- Maintainer  :  joost.visser@di.uminho.pt
-- Stability   :  experimental
-- Portability :  portable
--
-- This module defines the customizable pretty-printer and the top-level
-- function to pretty-print a PLSql AST.
--
-------------------------------------------------------------------------------
module Language.PLSql.Pretty where


import GPP
import Language.PLSql.Syntax
import Language.PLSql.SyntaxPP
import Language.PLSql.TermInstances
import Text.PrettyPrint.HughesPJ


-- renderPLSql :: (Term a) => a -> String
renderPLSql a = renderFix uppPLSqlSyntaxCustom a


uppPLSqlSyntaxCustom :: UPP
uppPLSqlSyntaxCustom gpp
  = uppPLSqlSyntax gpp
     `adhocQ` (ppPl_statements gpp)
     `adhocQ` (ppTable_items_opt_brackets gpp)
     `adhocQ` (ppTable_items gpp)
   where ppPl_statements :: GPP -> Pl_statements -> Doc
         ppPl_statements gpp (Pl_statements_c1 _0 _1) =  (gpp _0) <> (gppMaybe gpp _1)
         ppPl_statements gpp (Pl_statements_c2 _0 _1 _2) = ((gpp _0) <> (gpp _1)) $$ (gpp _2)
         
         ppTable_items_opt_brackets :: GPP -> Table_items_opt_brackets -> Doc
         ppTable_items_opt_brackets gpp (Table_items_opt_brackets_c1 _1)
            = (hang (gpp "(") 4 (gpp _1)) $$ (gpp ")")
         ppTable_items_opt_brackets gpp (Table_items_opt_brackets_c2 _0) 
            = hang empty 4 (gpp _0)
         
         ppTable_items :: GPP -> Table_items -> Doc
         ppTable_items gpp (Table_items _0) = vcat $ punctuate (gpp ",") (map gpp _0)

