

module PrettyPrint.Tables.Tables where

import PrettyPrint.Tables.Data_Lazy
import PrettyPrint.Tables.Visfun_Lazy




asciiT t =  putStrLn $ showT s
  where (_,_,s,_,_,_,_) = lrcEval t

asciiT' t =  showT s
  where (_,_,s,_,_,_,_) = lrcEval t



latexT t = show l
  where (_,l,_,_,_,_,_) = lrcEval t

htmlT t = putStrLn $ show h
  where (h,_,_,_,_,_,_) = lrcEval t


showT [] = ""
showT(h:t) = h ++ "\n" ++ showT t 


-- single 

mkTable = C_RootR_1 
               (C_RootTable_1 [C_AttrAny_1 "border" "true"] 
                  ((C_OneRow_1 [C_TableText_1 [] (C_CText_1 "JOAO")]  ) :
                   (C_OneRow_1   []  ) : []
                  )
               )                  
  
{-
a = "aaaa"  <|> "bbbb" <|> "cccc" <->
    "eeeee" <|> "gggg" <|> "aaaa" 
-}

list2VTable :: Show a => [a] -> Table
list2VTable l = C_RootTable_1 [C_AttrAny_1 "border" "true",C_Align_1 "left"] (list2VTable' l)
  where list2VTable' []    = []
        list2VTable' (h:t) = (C_OneRow_1 [C_TableText_1 [] (C_CText_1 (show h))]) : (list2VTable' t)



a = [ ["This","is","the","first","row"]
    , ["and","the","","second"]
    ]


matrix2table :: [[String]] -> R
matrix2table m = C_RootR_1  (C_RootTable_1 [C_AttrAny_1 "border" "true"] c)
 where c = map row m

       row a = C_OneRow_1 (map elem a)

       elem a = C_TableText_1 [] (C_CText_1 a)
                  
{-
Tables> asciiT $ matrix2table a
|---------------------------------|
|"This"|"is" |"the"|"first" |"row"|
|---------------------------------|
|"and" |"the"|""   |"second"|     |
|---------------------------------| 
-}


a' = [ [["This","is","the"],["first","row"]] 
     , [] 
     , [["and","the","","second"],["a"]]
     , [["bb","cc"],["aa"]]
     ]


matrix2tableList :: Show a => [[[a]]] -> R
matrix2tableList m = C_RootR_1  (C_RootTable_1 [C_AttrAny_1 "border" "true" 
                                               ,C_Align_1 "right"] c)
 where c = map row m

       row a = C_OneRow_1 (map elem a)

       elem a = C_NestedTable_1 (list2VTable a)
            


h = [["aa"],["bb","bbb"],["ccc"]]

b = [ (["xxx","yyyy"], [ ["a" ] , ["b","c" ] , ["d"]  ])
    , (["xxx","yyyy"], [ ["a" ] , ["b","c" ] , ["d"]  ])
    ]


-- matrix2tableList' :: (Show a, Show b, Show c) => [a] -> [(b,[c])] -> R
matrix2tableList' header body = matrix2tableList body''
  where body' = map (\(a,b) -> a : b) body
        body'' = ([[]] : header) : body'




header = ["mon","tue","wed","thu","fri","sat","sun"]
left   = ["", "9:00","10:00","11:00","12:00"]

body   = [ [ "fp", "" ,"pl","fp","afp","","" ]
         , [ "", "afp" ,"pl","fp","fp","","" ]
        ]

matrix2table' :: [String] -> [String] -> [[String]] -> R
matrix2table' header left body =  matrix2table matrix'
  where body'  = header : body
        left'  = left
        matrix = zip left' body'
        matrix' = map (\(a,b) -> a:b) matrix 
          


body' = [ ("9:00" ,[ "fp", "" ,"pl","fp","afp","","" ])
        , ("10:00",[ "", "afp" ,"pl","fp","fp","","" ])
        ]




matrix2table'' body =  matrix2table body'
  where body' = map (\(a,b) -> (show a) : (map show b)) body

{-
          HHHHHHHHHHHHHH
        b bbbbbbbbbbbbbb
        b bbbbbbbbbbbbbb
 
-}

matrix2table''' header body =  matrix2table body''
  where body' = map (\(a,b) -> (show a) : (map show b)) body
        body'' = ("" : (map show header) ) : body'

         

